/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://www.wtfpl.net/ for more details. */

#ifndef SETTINGS_H_
#define SETTINGS_H_

#include <string>

#define SECTION "Settings"
#define LOG_MODE "logmode"

struct Settings
    {
    Settings();

    std::string gamePath;
    std::string falloutExeOverride;
    std::string falloutCfgOverride;
    std::string falloutLngDirOverride;
    std::string lngFile;
    int brightness;
    int logMode;
    int imageResizeQuality;
    bool isFallout1;
    bool correctItemFID;
    bool correctAmmoType;
    bool correctAmmoQuantity;
    bool correctPerks;


    bool NeedLocalize() const {return !lngFile.empty();}
    bool Load(const std::string& inifile);
    void Save(const std::string& inifile);
    void TryToGuessLng();
    };

#endif // SETTINGS_H_
